Index: deliver.c
===================================================================
--- deliver.c	(revision 94)
+++ deliver.c	(working copy)
@@ -55,6 +55,7 @@
 
 static struct module *modules;
 static struct ioloop *ioloop;
+static const char *envelope_sender;
 
 static void sig_die(int signo, void *context __attr_unused__)
 {
@@ -155,6 +156,11 @@
 	const char *str;
 
 	str = mail_get_first_header(mail, "Return-Path");
+	if(!str)
+		str = envelope_sender != DEFAULT_ENVELOPE_SENDER
+		 ? envelope_sender	/* -f option */
+		 : mail_get_first_header(mail, "From");	/* That's not the
+			most correct one, but alas */
 	addr = str == NULL ? NULL :
 		message_address_parse(pool_datastack_create(),
 				      (const unsigned char *)str,
@@ -467,7 +473,6 @@
 int main(int argc, char *argv[])
 {
 	const char *config_path = DEFAULT_CONFIG_FILE;
-	const char *envelope_sender = DEFAULT_ENVELOPE_SENDER;
 	const char *mailbox = "INBOX";
 	const char *auth_socket, *env_tz;
 	const char *home, *destination, *user, *mail_env, *value;
@@ -482,6 +487,7 @@
 	uid_t process_euid;
 	int i, ret;
 
+	envelope_sender = DEFAULT_ENVELOPE_SENDER;
 	i_set_failure_exit_callback(failure_exit_callback);
 
 	lib_init();
